import VueCookie from "vue-cookie"
const image_upload_props = (limit = 5, extranote = "") => {
  return {
    type: 'upload',
    listType: 'picture-img',
    span: 24,
    accept: 'image/png, image/jpeg',
    limit: 1,
    fileSize: 5 * 1024,
    row: true,
    headers: {
      "Authorization": VueCookie.get("Authorization")
    },
    propsHttp: {
      url: 'data'
    },
    tip: `${extranote}只能上传jpg/png图片，且不超过${limit}MiB`,
    action: `${process.env.VUE_APP_BASE_API || ""}/file/upload`
  }
}

export default (isnew = false) => {
  return {
    labelWidth: 100,
    column: [
      {
        label: '直播间名称',
        prop: 'title',
        row: true,
        span: 12,
        rules: [{ required: true, message: "直播间名称 为必填项" }]
      }, {
        label: "分享摘要",
        prop: "summary",
        row: true,
        span: 16,
      }, {
        label: "分享图",
        prop: "imageShare",
        ...image_upload_props(1, "建议尺寸：300x300px，"),
      }, {
        label: '直播封面',
        prop: "imageCover",
        ...image_upload_props(5, "建议尺寸：1080x1920px，"),
      }, {
        label: '直播类型',
        prop: 'videoKind',
        type: 'radio',
        span: 8,
        row: true,
        dicData: [
          { value: "vertical", label: "竖屏" },
          { value: "horizontal", label: "横屏" }
        ],
      }, {
        label: "是否首页显示",
        prop: "showInList",
        type: 'switch',
        row: true,
        dicData: [{
          label: '否',
          value: false
        }, {
          label: '是',
          value: true
        }],
      }, {
        label: "订阅通知类型",
        prop: "followNoticeType",
        type: 'checkbox',
        row: true,
        dicData: [{
          label: '掌银小信封',
          value: 'zy'
        }, {
          label: '微信订阅消息',
          value: 'wx',
          disabled: true
        }]
      }, {
        label: "直播时长",
        prop: "hours",
        type: "number",
        step: 1,
        precision: 0,
        span: 6,
        row: true,
        tip: "单位为小时",
      }, {
        label: '直播间描述',
        prop: 'desc',
        type: 'textarea',
        minRows: 3,
        maxRows: 5,
        span: 16,
        row: true,
      }, {
        label: '直播间公告',
        prop: 'announcement',
        type: 'textarea',
        minRows: 3,
        maxRows: 5,
        span: 16,
        row: true,
      }
    ]
  }
}