import { database2real } from "./currency"
import dayjs, { Dayjs } from 'dayjs'

export const currencyFormatter = (v) => "￥" + database2real(v).toFixed(2)
export const row_currencyFormatter = (_, v) => v ? ("￥" + database2real(v).toFixed(2)) : "-"

export function datetime_format(v, format = "YYYY-MM-DD HH:mm:ss"){
    v = v || new Date()
    if (v instanceof Date || typeof v === 'string') {
        return dayjs(v).format(format)
    } else {
        return v.format(format)
    }
}

export function datetime_format_short(v) {
    return datetime_format(v, "M-DD HH:mm")
}